import { readFileSync, writeFileSync } from '../fs/fs.mjs';
import { getFs } from '../nodejs/fs.mjs';
import { getGlob } from '../third-party/glob.mjs';
import { checkValidReplaceList } from './helper.mjs';
import '../nodejs/crypto.mjs';
import '../nodejs/os.mjs';

function _createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t["return"] || t["return"](); } finally { if (u) throw o; } } }; }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function replaceContentSimple(_ref) {
  var replaceList = _ref.replaceList;
  var _iterator = _createForOfIteratorHelper(replaceList),
    _step;
  try {
    var _loop = function _loop() {
        var item = _step.value;
        var dirList = item.dirList,
          to = item.to,
          from = item.from,
          list = item.list;
        var newDir = Array.isArray(dirList) ? dirList : [dirList];
        if (!(newDir === null || newDir === void 0 ? void 0 : newDir.length)) return 0; // continue
        if (list === null || list === void 0 ? void 0 : list.length) {
          checkValidReplaceList(list);
          list.forEach(function (inner) {
            replaceEachContent({
              dirList: newDir,
              to: (inner === null || inner === void 0 ? void 0 : inner[1]) || '',
              from: (inner === null || inner === void 0 ? void 0 : inner[0]) || ''
            });
          });
          return 0; // continue
        }
        if (!from) return 0; // continue
        replaceEachContent({
          dirList: newDir,
          to: to || '',
          from: from
        });
      },
      _ret;
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      _ret = _loop();
      if (_ret === 0) continue;
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
}
function replaceEachContent(_ref2) {
  var dirList = _ref2.dirList,
    to = _ref2.to,
    from = _ref2.from;
  var glob = getGlob();
  var list = glob.sync(dirList);
  if (!from) {
    throw new Error('[replaceEachContent] from 不能为空!');
  }
  var _iterator2 = _createForOfIteratorHelper(list),
    _step2;
  try {
    for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
      var file = _step2.value;
      if (getFs().statSync(file).isDirectory()) {
        continue;
      }
      var content = readFileSync(file);
      var newContent = content;
      if (typeof from === 'string') {
        newContent = content.replaceAll(from, to);
      } else {
        newContent = content.replace(from, to);
      }
      writeFileSync(file, newContent);
      console.log("[Replace Content]: \u6587\u4EF6: ".concat(file, ", from: ").concat(from, ", to: ").concat(to));
    }
  } catch (err) {
    _iterator2.e(err);
  } finally {
    _iterator2.f();
  }
}

export { replaceContentSimple };
